import { j as N } from "../../../node_modules/react/jsx-runtime.mjs";
import T from "../../../hooks/useMergedState.mjs";
import { createContext as j, useRef as I, useMemo as E, useState as P, useEffect as v, useCallback as L } from "react";
import { genColumnKey as R } from "./utils/index.mjs";
import M from "../../../node_modules/lodash-es/merge.mjs";
function k(e = {}) {
  var y, w, C, K, h, g;
  const o = I([]), { defaultSize: x = "lg" } = e, [z, O] = T(() => e.size ?? x, {
    value: e.size,
    onChange: e.onSizeChange
  }), m = E(() => {
    var u, t;
    if ((u = e == null ? void 0 : e.columnsState) != null && u.defaultValue)
      return e.columnsState.defaultValue;
    const n = {};
    return (t = e.columns) == null || t.forEach(({ key: c, dataIndex: l, fixed: a, disable: i }, s) => {
      const V = R(c ?? l, s);
      V && (n[V] = {
        show: !0,
        fixed: a,
        disable: i
      });
    }), n;
  }, [e.columns]), [b, J] = P({}), [f, r] = T(() => {
    var t, c, l, a;
    const { persistenceType: n, persistenceKey: u } = e.columnsState || {};
    if (u && n && typeof window < "u") {
      const i = window[n];
      try {
        const s = i == null ? void 0 : i.getItem(u);
        if (s)
          return (t = e == null ? void 0 : e.columnsState) != null && t.defaultValue ? M(JSON.parse(s), (c = e == null ? void 0 : e.columnsState) == null ? void 0 : c.defaultValue) : JSON.parse(s);
      } catch (s) {
        console.warn(s);
      }
    }
    return e.columnsStateMap || ((l = e.columnsState) == null ? void 0 : l.value) || ((a = e.columnsState) == null ? void 0 : a.defaultValue) || m;
  }, {
    value: ((y = e.columnsState) == null ? void 0 : y.value) || e.columnsStateMap,
    onChange: ((w = e.columnsState) == null ? void 0 : w.onChange) || e.onColumnsStateChange
  });
  v(() => {
    var t, c;
    const { persistenceType: n, persistenceKey: u } = e.columnsState || {};
    if (u && n && typeof window < "u") {
      const l = window[n];
      try {
        const a = l == null ? void 0 : l.getItem(u);
        a ? (t = e == null ? void 0 : e.columnsState) != null && t.defaultValue ? r(M(JSON.parse(a), (c = e == null ? void 0 : e.columnsState) == null ? void 0 : c.defaultValue)) : r(JSON.parse(a)) : r(m);
      } catch (a) {
        console.warn(a);
      }
    }
  }, [
    (C = e.columnsState) == null ? void 0 : C.persistenceKey,
    (K = e.columnsState) == null ? void 0 : K.persistenceType,
    m
  ]);
  const S = L(() => {
    const { persistenceType: n, persistenceKey: u } = e.columnsState || {};
    if (!u || !n || typeof window > "u")
      return;
    const t = window[n];
    try {
      t == null || t.removeItem(u);
    } catch (c) {
      console.warn(c);
    }
  }, [e.columnsState]);
  v(() => {
    var c, l;
    if (!((c = e.columnsState) != null && c.persistenceKey) || !((l = e.columnsState) != null && l.persistenceType) || typeof window > "u")
      return;
    const { persistenceType: n, persistenceKey: u } = e.columnsState, t = window[n];
    try {
      t == null || t.setItem(u, JSON.stringify(f));
    } catch (a) {
      console.warn(a), S();
    }
  }, [
    (h = e.columnsState) == null ? void 0 : h.persistenceKey,
    f,
    (g = e.columnsState) == null ? void 0 : g.persistenceType
  ]);
  const d = {
    sortKeyColumns: o.current,
    setSortKeyColumns: (n) => {
      o.current = n;
    },
    columnList: b,
    setColumnList: J,
    columnsMap: f,
    setColumnsMap: r,
    setTableSize: O,
    tableSize: z,
    columns: e.columns,
    clearPersistenceStorage: S,
    defaultColumnKeyMap: m
  };
  return Object.defineProperty(d, "sortKeyColumns", {
    get: () => o.current
  }), d;
}
const q = j({}), H = (e) => {
  const o = k(e.initValue);
  return N.jsx(q.Provider, { value: o, children: e.children });
};
export {
  q as TableContext,
  H as default
};
