import { j as s } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as G, useModal as H, antdModalV5 as J } from "@ebay/nice-modal-react";
import { Modal as P, Checkbox as Q } from "antd";
import t from "./index.module.less.mjs";
import { useState as U, useContext as X, useCallback as I, useMemo as j } from "react";
import { TableContext as Y } from "../../Store/index.mjs";
import { genColumnKey as B, columnSort as Z } from "../../Store/utils/index.mjs";
import g from "../../../../node_modules/classnames/index.mjs";
import { DndContext as _, DragOverlay as $, defaultDropAnimationSideEffects as ee } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as se, verticalListSortingStrategy as le, arrayMove as oe } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import te from "./DndItem.mjs";
import { restrictToVerticalAxis as ne, restrictToWindowEdges as ae } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import K from "../../../../node_modules/lodash-es/omit.mjs";
import ce from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import ie from "../../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const de = {
  sideEffects: ee({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, De = G(() => {
  var S;
  const v = H(), C = J(v), [u, b] = U(null), { columnList: F, setColumnList: O, columnsMap: i, setColumnsMap: p, sortKeyColumns: x, setSortKeyColumns: T, clearPersistenceStorage: y, ...o } = X(Y), R = I(() => {
    y == null || y(), p(o.defaultColumnKeyMap);
  }, []), h = j(() => {
    var l, n;
    const e = [];
    return (l = o == null ? void 0 : o.columns) != null && l.length && ((n = o == null ? void 0 : o.columns) == null || n.map(({ key: m, dataIndex: a, ...d }) => {
      const f = B(m || a, [m || a].filter(Boolean).join("-")), r = i[f || "null"];
      return (r == null ? void 0 : r.show) !== !1 && e.push({
        key: f,
        ...K(d, ["className"]),
        selectable: !1,
        disabled: (r == null ? void 0 : r.disable) === !0
      }), r;
    })), e.sort(Z(i));
  }, [i, o == null ? void 0 : o.columns]), k = I((e) => x == null ? void 0 : x.findIndex((l) => l === e), [x]), E = j(() => u ? k(u) : -1, [u, k]), D = j(() => {
    const e = [], l = /* @__PURE__ */ new Map();
    return { list: ((m, a) => m.map(({ key: d, dataIndex: f, children: r, ...M }) => {
      var w;
      const N = B(d || f, [a == null ? void 0 : a.columnKey, M.index].filter(Boolean).join("-")), c = i[N || "null"] || { show: !0 };
      (c == null ? void 0 : c.show) !== !1 && !r && e.push(N);
      const A = {
        key: N,
        ...K(M, ["className"]),
        selectable: !1,
        disabled: c.disable === !0,
        disableCheckbox: typeof c.disable == "boolean" ? c == null ? void 0 : c.disable : (w = c == null ? void 0 : c.disable) == null ? void 0 : w.checkbox,
        isLeaf: a ? !0 : void 0
      };
      return l.set(d, A), A;
    }))(o == null ? void 0 : o.columns), keys: e, map: l };
  }, [i, o == null ? void 0 : o.columns]), V = (e, l) => {
    const n = { ...i };
    ((a) => {
      const d = { ...n[a] };
      d.show = !e, n[a] = d;
    })(l.key), p({ ...n });
  }, L = (e, l) => {
    const n = { ...i }, m = oe(x, e, l);
    m.forEach((a, d) => {
      n[a] = { ...n[a] || {}, order: d };
    }), p(n), T(m);
  }, W = j(() => {
    var e, l;
    return u ? ((l = (e = o == null ? void 0 : o.columns) == null ? void 0 : e.find((n) => n.key === u)) == null ? void 0 : l.title) ?? "" : "";
  }, [o == null ? void 0 : o.columns, u, i, x]), q = () => {
    O({ ...i }), v.resolve({ ...i }), v.hide();
  }, z = () => {
    p({ ...F }), C.onCancel();
  };
  return s.jsxs(P, { title: "自定义列", ...C, width: 600, onOk: q, onCancel: z, children: [s.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }), s.jsxs("div", { className: t.contaiern, children: [s.jsxs("div", { className: t.block, children: [s.jsxs("div", { className: t.header, children: [s.jsx("div", { className: t.title, children: "可用列" }), s.jsx("div", {})] }), s.jsx("div", { className: t.body, children: s.jsx("ul", { className: t.content, children: (S = D.list) == null ? void 0 : S.map((e) => {
    const l = D.keys.includes(e.key);
    return s.jsxs("li", { className: g(t.item, {
      [t.checked]: !l
    }), onClick: () => !e.disabled && V(l, e), children: [s.jsx(Q, { checked: l, disabled: e.disabled }), s.jsx("span", { className: t["content-item-text"], children: e.title })] }, e.key);
  }) }) })] }), s.jsxs("div", { className: t.block, children: [s.jsxs("div", { className: t.header, children: [s.jsx("div", { className: t.title, children: "选定的列" }), s.jsxs("div", { className: t.reset, onClick: R, children: [s.jsx("div", { children: "重置  " }), s.jsx(ce, {})] })] }), s.jsx("div", { className: t.body, children: s.jsxs(_, { modifiers: [ne, ae], onDragStart: (e) => {
    const { active: l } = e;
    l && b(l == null ? void 0 : l.id);
  }, onDragCancel: () => b(null), onDragEnd: (e) => {
    b(null);
    const { over: l } = e;
    if (l) {
      const n = k(l.id);
      E !== n && L(E, n);
    }
  }, children: [s.jsx(se, { items: h == null ? void 0 : h.map((e) => e.key), strategy: le, children: s.jsx("ul", { className: t.content, style: { background: "#fff" }, children: h == null ? void 0 : h.map((e) => s.jsx(te, { item: e }, e.key)) }) }), s.jsx($, { adjustScale: !1, dropAnimation: de, children: u ? s.jsxs("li", { className: g(t.moveItem), children: [s.jsx(ie, { className: t.dragIcon }), s.jsx("span", { className: t["moveItem-text"], children: W })] }) : null })] }) })] })] })] });
});
export {
  De as default
};
